using Bp.Sync.BackEnd.Infrastructure.ElasticDbContext;
using Bp.Sync.Domain.Elastics.Inventories.Accounts;
using Bp.Sync.Dto.Results;
using Bp.Sync.Dto.SmartTable;
using Microsoft.Extensions.Options;
using Nest;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace Bp.Sync.BackEnd.Infrastructure.Repositories
{
    public interface IAccountRepository
    {
        Task<BaseResult> Add(AccountElastic Account);
        Task<BaseResult> AddManyAsync(IEnumerable<AccountElastic> Accounts);
        Task<SmartTableResult<AccountElastic>> Search(BoolQueryDescriptor<AccountElastic> query);

    }
    public class AccountRepository : IAccountRepository
    {
        private readonly ElasticIndex<AccountElastic> _dbContext;

        public AccountRepository(IOptions<ElasticConnectionSettings> settings)
        {
            _dbContext = new ElasticIndex<AccountElastic>(settings.Value.ClusterUrl, "inventoryaccount");
        }


        public async Task<SmartTableResult<AccountElastic>> Search(BoolQueryDescriptor<AccountElastic> query)
        {
            return await _dbContext.Search(query);
        }


        public async Task<BaseResult> Add(AccountElastic Account)
        {
            var result = new BaseResult() { Result = Dto.Results.Result.Success };
            var rs = await _dbContext.Insert(Account);
            if (rs.IsValid)
            {
                result.Result = Dto.Results.Result.Success;
            }
            else
            {
                result.Result = Dto.Results.Result.SystemError;
                result.Message = "Không tạo được bản ghi";
            }
            return result;
        }
        public async Task<BaseResult> AddManyAsync(IEnumerable<AccountElastic> Accounts)
        {
            var result = new BaseResult { Result = Dto.Results.Result.Success };
            try
            {
                var rs = await _dbContext.InsertMany(Accounts);
                if (rs.IsValid) return result;
                else
                {
                    result.Result = Dto.Results.Result.Failed;
                    result.Message = rs.Errors.ToString();
                    return result;
                }
            }
            catch (Exception exx)
            {
                result.Result = Dto.Results.Result.Failed;
                result.Message = exx.Message.ToString();
                return result;
            }
        }

    }
}
